if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

lib.tooltip = {}
local this = lib.tooltip

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
		this.private.set = true
	end
	return
end

function this.private.Init()
	if(this.private.set == true) then
		return
	end
	
	if(TTD2_SCANNING_TOOLTIP == nil) then
		lib.chat.error("ScanningToolip missing!")
	end
	
	this.private.RequestToken = nil
	
	this.ItemTooltipNotReady = RETRIEVING_ITEM_INFO
	this.QuestTooltipNotReady = RETRIEVING_DATA
	
	return
end

function this.RequestItemByID(ItemID)
	this.private.Validate()
	
	TTD2_SCANNING_TOOLTIP:ClearLines()
	TTD2_SCANNING_TOOLTIP:SetHyperlink("item:"..ItemID)
	
	this.private.RequestToken = this.ItemTooltipNotReady
	
	return
end

function this.RequestQuestByID(QuestID)
	this.private.Validate()
	
	TTD2_SCANNING_TOOLTIP:ClearLines()
	TTD2_SCANNING_TOOLTIP:SetHyperlink("quest:"..QuestID)
	
	this.private.RequestToken = this.QuestTooltipNotReady
	
	return
end

function this.IsReady()
	this.private.Validate()
	
	if(this.private.RequestToken == nil) then
		return false
	end
	
	if(TTD2_SCANNING_TOOLTIP:GetRegions() == nil) then
		return false
	end
	
	for i=1, select("#",TTD2_SCANNING_TOOLTIP:GetRegions()) do
		local Region = select(i,TTD2_SCANNING_TOOLTIP:GetRegions())
		if(Region ~= nil and Region:GetObjectType() == "FontString" and Region:GetText() ~= nil) then
			--this is the first text region
			if(Region:GetText() == this.private.RequestToken) then
				return false
			else
				return true
			end
		end
	end
	
	return false
end

function this.DoesTextRegionExist(RegionIndex)
	this.private.Validate()
	
	if(this.private.RequestToken == nil) then
		return false
	end
	
	if(TTD2_SCANNING_TOOLTIP:GetRegions() == nil) then
		return false
	end
	
	local Region = select(RegionIndex,TTD2_SCANNING_TOOLTIP:GetRegions())
	if(Region == nil) then
		return false
	end
	
	if(Region:GetObjectType() ~= "FontString") then
		return false
	end
	
	return true
end

function this.IsRegionTextReady(RegionIndex)
	this.private.Validate()
	
	if(this.private.RequestToken == nil) then
		return false
	end
	
	if(TTD2_SCANNING_TOOLTIP:GetRegions() == nil) then
		return false
	end
	
	local Region = select(RegionIndex,TTD2_SCANNING_TOOLTIP:GetRegions())
	if(Region == nil) then
		return false
	end
	
	if(Region:GetObjectType() ~= "FontString") then
		return false
	end		
	
	local Text = Region:GetText()
	if(Text == nil or Text == this.private.RequestToken) then
		return false
	end
	
	return true
end

function this.PrintAllFontRegions()
	this.private.Validate()
	
	if(this.private.RequestToken == nil) then
		return
	end
	
	if(TTD2_SCANNING_TOOLTIP:GetRegions() == nil) then
		return
	end
	
	for i=1, select("#",TTD2_SCANNING_TOOLTIP:GetRegions()) do
		local Region = select(i,TTD2_SCANNING_TOOLTIP:GetRegions())
		if(Region ~= nil and Region:GetObjectType() == "FontString" and Region:GetText() ~= nil) then
			print(i..": "..Region:GetText())
		end
	end
	
	return
end

function this.GetRegionText(RegionIndex)
	this.private.Validate()
	
	if(this.private.RequestToken == nil) then
		return nil
	end
	
	if(TTD2_SCANNING_TOOLTIP:GetRegions() == nil) then
		return nil
	end
	
	local Region = select(RegionIndex, TTD2_SCANNING_TOOLTIP:GetRegions())
	if(Region == nil or Region:GetObjectType() ~= "FontString") then
		return nil
	end
	
	return Region:GetText()
end

--deprecated
function this.SearchTextFromBottom(Text)
	this.private.Validate()
	
	--this function iterates over all TextRegions of the tooltip from the bottom and tries to match content with Text
	
	if(this.private.RequestToken == nil) then
		return false
	end
	
	if(TTD2_SCANNING_TOOLTIP:GetRegions() == nil) then
		return false
	end
	
	local NumTokens = select("#",TTD2_SCANNING_TOOLTIP:GetRegions())

	if(NumTokens == 0) then
		return false
	end
	
	for i = NumTokens, 1, -1 do
		local Region = select(i,TTD2_SCANNING_TOOLTIP:GetRegions())
		if(Region ~= nil and Region:GetObjectType() == "FontString" and Region:GetText() == Text) then
			return true
		end
	end
	
	return false
end

function this.GetTextLines()
	this.private.Validate()
	
	if(this.private.RequestToken == nil) then
		return nil
	end
	
	if(TTD2_SCANNING_TOOLTIP:GetRegions() == nil) then
		return nil
	end
	
	local NumTokens = select("#",TTD2_SCANNING_TOOLTIP:GetRegions())

	local Lines = {}
	if(NumTokens == 0) then
		return Lines
	end
	
	for i = 1, NumTokens do
		local Region = select(i,TTD2_SCANNING_TOOLTIP:GetRegions())
		if(Region ~= nil and Region:GetObjectType() == "FontString") then
			Lines[#Lines+1] = Region:GetText()
		end
	end
	
	return Lines
end
