if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.ArgusMounts = {}
local this = ttd2.ArgusMounts
this.Name = "[Argus] Mounts"

--[[
The purpose of this module is to check your status of the various argus-outdoor mounts against available WQs
]]

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
		this.private.set = true
	end
	
	return
end

function this.private.Init()
	if(this.private.set) then
		return
	end
	
	this.private.mounts =
	{
		{ ItemID = 152790, JournalID = 955, src = { MapID = 885, x = 0.631, y = 0.253, FlagQuest = 48821, WQuest = 48835, Name = "Kerrax" } }, --übles scheusal
		{ ItemID = 152905, JournalID = 979, src = { MapID = 885, x = 0.618, y = 0.373, FlagQuest = 49183, WQuest = 47561, Name = "Blasenmaul" } }, --purpurroter geiferschlund
		{ ItemID = 152903, JournalID = 981, src = { MapID = 885, x = 0.532, y = 0.358, FlagQuest = 48810, WQuest = 48465, Name = "Vrax'thul" } }, --gallzahnknirscher
		{ ItemID = 152903, JournalID = 981, src = { MapID = 885, x = 0.655, y = 0.267, FlagQuest = 48809, WQuest = 48467, Name = "Puscilla" } }, --gallzahnknirscher
		{ ItemID = 152904, JournalID = 980, src = { MapID = 882, x = 0.496, y = 0.100, FlagQuest = 48721, WQuest = 48740, Name = "Skreeg" } }, --säurespucker
		{ ItemID = 152814, JournalID = 970, src = { MapID = 882, x = 0.557, y = 0.598, FlagQuest = 48695, WQuest = 48696, Name = "Kravos" } } --wahnsinniger chaosläufer
	}
	
	local mounts = this.private.mounts
	for _,mount in pairs(mounts) do
		lib.item.AddByID(mount.ItemID)
		lib.journal.mount.AddByID(mount.JournalID)
		lib.quest.AddByID(mount.src.FlagQuest)
		mount.src.Name = lib.worldquest.GetNameByID(mount.src.WQuest)
	end
	
	return
end

function this.private.Update()
	this.private.Validate()
	
	local mounts = this.private.mounts
	
	for _,mount in pairs(mounts) do
		lib.item.UpdateByID(mount.ItemID)
		lib.journal.mount.UpdateByID(mount.JournalID)
		lib.quest.UpdateByID(mount.src.FlagQuest)
	end
	
	local out = lib.chat.output
	out.ClearBuffer()
	
	for _,mount in pairs(mounts) do
		local MountData = lib.journal.mount.GetByID(mount.JournalID)
		local Link = lib.item.GetByID(mount.ItemID).Link
		if(MountData.IsCollected == true) then
			out.StoreCompleted(Link)
		elseif(lib.quest.GetByID(mount.src.FlagQuest).IsCompleted == true) then
			out.StoreDone(Link)
		elseif(lib.worldquest.IsActive(mount.src.WQuest) == true) then
			--its only todo if the WQ is up
			out.StoreTodo(Link.." - "..lib.chat.complex.GetWQStatusString(mount.src.WQuest))
		else
			--if WQ is not up, it's rare
			local TomTom = lib.tomtom.createLink(mount.src.MapID, mount.src.x, mount.src.y, mount.src.Name)
			out.StoreRare(Link.." - "..TomTom)
		end
	end
	
	return
end

function this.CheckStatus()
	this.private.Validate()
	
	this.private.Update()
	if(lib.chat.output.GetNumLines() == 0) then
		return false
	end
	
	return true
end

function this.Script()
	this.private.Validate()
	
	this.private.Update()
	lib.chat.output.PrintModule(this.Name)
	
	return
end

mod[#mod+1] =
{
	CheckStatus	= this.CheckStatus,
	Text		= this.Name,
	Script		= this.Script
}
