if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.BFABonusRoll = {}
local this = ttd2.BFABonusRoll
this.Name = "[BFA] Bonus-Roll"

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
		this.private.set = true
	end
	
	return
end

function this.private.Init()
	if(this.private.set == true) then
		return
	end
	
	this.private.Quests =
	{
		52837, 52840,	--Vendor: OHR
		52834, 52838,	--Vendor: Gold
		52835, 52839	--Vendor: PVP
	}

	this.private.Currency =
	{
		ID			= 1580, --BFA bonusroll currency
		WeeklyMax	= 2,
	}
	
	for _,QuestID in pairs(this.private.Quests) do
		lib.quest.AddByID(QuestID)
	end
	
	lib.currency.AddByID(this.private.Currency.ID)
	
	return
end

function this.private.Update()
	this.private.Validate()
	
	for _,QuestID in pairs(this.private.Quests) do
		lib.quest.UpdateByID(QuestID)
	end
	
	lib.currency.UpdateByID(this.private.Currency.ID)
	
	local out = lib.chat.output
	out.ClearBuffer()
	
	--cannot trade bonus rolls before 120
	if(lib.unit.GetPlayerLevel() < 120) then
		return
	end
	
	local CurrencyData = lib.currency.GetByID(this.private.Currency.ID)
	
	local Traded = 0
	for _,QuestID in pairs(this.private.Quests) do
		if(lib.quest.GetByID(QuestID).IsCompleted == true) then
			Traded = Traded+1
		end		
	end
	
	if((Traded < this.private.Currency.WeeklyMax) and (CurrencyData.Amount < CurrencyData.TotalMax)) then
		out.StoreTodo(CurrencyData.Link..lib.chat.yellow(" "..Traded.." / "..this.private.Currency.WeeklyMax))
	elseif(Traded == this.private.Currency.WeeklyMax) then
		out.StoreCompleted(CurrencyData.Link..lib.chat.green(" "..Traded.." / "..this.private.Currency.WeeklyMax))
	else
		out.StoreDone(CurrencyData.Link..lib.chat.yellow(" "..Traded.." / "..this.private.Currency.WeeklyMax).." traded, but at cap of "..lib.chat.red(CurrencyData.Amount.." / "..CurrencyData.TotalMax))
	end
	return
end

function this.CheckStatus()
	this.private.Validate()
	
	this.private.Update()
	if(lib.chat.output.GetNumLines() == 0) then
		return false
	end
	
	return true
end

function this.Script()
	this.private.Validate()
	
	this.private.Update()
	lib.chat.output.PrintModule(this.Name)
	
	return
end

mod[#mod+1] =
{
	CheckStatus	= this.CheckStatus,
	Text		= this.Name,
	Script		= this.Script
}
