if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.LegionParagon = {}
local this = ttd2.LegionParagon
this.Name = "[Legion] Paragon"

--[[
This module will only report missing paragon as "todo" if the emissary is up. If the emissary is not up it will
be printed as "done".
]]

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
		this.private.set = true
	end
	
	return
end

function this.private.Init()
	if(this.private.set == true) then
		return
	end
	
	this.private.Paragon =
	{
		--Farondis =
		{
			FactionID = 1900,
			EmissaryID = 42420,
			BoxID = 146897,
			mounts =
			{
				{ItemID = 147806, ID = 943}
			},
			pets = {},
			toys = {}
		},
		--Traumweber =
		{
			FactionID = 1883,
			EmissaryID = 42170,
			BoxID = 146898,
			mounts =
			{
				{ItemID = 147804, ID = 942}
			},
			pets = {},
			toys = {}
		},
		--Highmountain =
		{
			FactionID = 1828,
			EmissaryID = 42233,
			BoxID = 146899,
			mounts =
			{
				{ItemID = 147807, ID = 941}
			},
			pets = {},
			toys = {}
		},
		--Valarjar =
		{
			FactionID = 1948,
			EmissaryID = 42234,
			BoxID = 146901,
			mounts =
			{
				{ItemID = 147805, ID = 944}
			},
			pets = {},
			toys = {}
		},
		--Suramar =
		{
			FactionID = 1859,
			EmissaryID = 42421,
			BoxID = 146900,
			mounts =
			{
				{ItemID = 143764, ID = 905}
			},
			pets = {},
			toys = {}
		},
		--Watchers =
		{
			FactionID = 1894,
			EmissaryID = 42422,
			BoxID = 146902,
			mounts = {},
			pets = {},
			toys =
			{ 
				{ItemID = 147843, ID = 0}
			}
		},
		--Legionsrichter =
		{
			FactionID = 2045,
			EmissaryID = 48641,
			BoxID = 147361,
			mounts = {},
			pets =
			{
				{ItemID = 147841, ID = 2050}
			},
			toys = {}
		},
		--ArmeeDesLichts =
		{
			FactionID = 2165,
			EmissaryID = 48639,
			BoxID = 152923,
			mounts =
			{ 
				{ItemID = 153042, ID = 983},
				{ItemID = 153043, ID = 984},
				{ItemID = 153044, ID = 985}
			},
			pets = {},
			toys =
			{ 
				{ItemID = 153182, ID = 0}
			}
		}
	}
	
	for _,Faction in pairs(this.private.Paragon) do
		lib.faction.AddByID(Faction.FactionID)
		lib.quest.AddByID(Faction.EmissaryID)
		lib.item.AddByID(Faction.BoxID)
		
		if(Faction.mounts ~= nil) then
			for _,Mount in pairs(Faction.mounts) do
				lib.item.AddByID(Mount.ItemID)
				lib.journal.mount.AddByID(Mount.ID)
			end
		end
		
		if(Faction.pets ~= nil) then
			for _,Pet in pairs(Faction.pets) do
				lib.item.AddByID(Pet.ItemID)
				lib.journal.pet.AddByID(Pet.ID)
			end
		end
		
		if(Faction.toys ~= nil) then
			for _,Toy in pairs(Faction.toys) do
				lib.item.AddByID(Toy.ItemID)
				lib.journal.toy.AddByID(Toy.ItemID)
			end
		end
	end
	
	this.private.Missing = {}
	
	return
end

function this.private.BuildMissing()
	this.private.Validate()
	
	lib.table.clear(this.private.Missing)
	
	local Index = 1
	for _,Faction in pairs(this.private.Paragon) do
		this.private.Missing[Index] = {}
		local Current = this.private.Missing[Index]
		Index = Index+1
		
		if(lib.faction.GetByID(Faction.FactionID).Paragon == nil) then
			Current.RewardPending		= false
			Current.Rep					= 0
			Current.RepNext				= 0
		else
			Current.RewardPending		= lib.faction.GetByID(Faction.FactionID).Paragon.HasRewardPending
			Current.Rep					= lib.faction.GetByID(Faction.FactionID).Paragon.CurrentRep
			Current.RepNext				= lib.faction.GetByID(Faction.FactionID).Paragon.NextRep
			while(Current.Rep > Current.RepNext) do
				Current.Rep = Current.Rep - Current.RepNext
			end
		end
		
		
		Current.Name				= lib.faction.GetByID(Faction.FactionID).Name
		Current.RewardLink			= lib.item.GetByID(Faction.BoxID).Link
		Current.SomethingMissing	= false
		Current.EmissaryActive		= lib.quest.GetByID(Faction.EmissaryID).IsInLog
		Current.EmissaryLink		= lib.quest.GetByID(Faction.EmissaryID).Link
		Current.EmissaryTimeLeft	= lib.quest.GetByID(Faction.EmissaryID).TimeLeftString
		
		--[[if(Current.EmissaryActive == true) then
			Current.EmissaryTimeLeft = C_TaskQuest.GetQuestTimeLeftMinutes(Faction.EmissaryID)
		else
			Current.EmissaryTimeLeft = nil
		end--]]
		
		if(Faction.mounts ~= nil) then
			Current.Mounts = {}
			for _,Mount in pairs(Faction.mounts) do
				Current.Mounts[#Current.Mounts+1] =
				{
					[1]=true,
					[2]=lib.item.GetByID(Mount.ItemID).Link
				}
				if(lib.journal.mount.GetByID(Mount.ID).IsCollected ~= true) then
					Current.Mounts[#Current.Mounts][1] = false
					Current.SomethingMissing = true
				end
			end
		end
		
		if(Faction.pets ~= nil) then
			Current.Pets = {}
			for _,Pet in pairs(Faction.pets) do
				Current.Pets[#Current.Pets+1] =
				{
					[1]=true,
					[2]=lib.item.GetByID(Pet.ItemID).Link,
					[3]=lib.journal.pet.GetByID(Pet.ID).NumCollected,
					[4]=lib.journal.pet.GetByID(Pet.ID).NumLimit
				}
				if(lib.journal.pet.GetByID(Pet.ID).IsCollected ~= true) then
					Current.Pets[#Current.Pets][1] = false
					Current.SomethingMissing = true
				end
			end
		end
		
		if(Faction.toys ~= nil) then
			Current.Toys = {}
			for _,Toy in pairs(Faction.toys) do
				Current.Toys[#Current.Toys+1] =
				{
					[1]=true,
					[2]=lib.item.GetByID(Toy.ItemID).Link
				}
				if(lib.journal.toy.GetByID(Toy.ItemID).IsCollected ~= true) then
					Current.Toys[#Current.Toys][1] = false
					Current.SomethingMissing = true
				end
			end
		end	
	end
	
	return
end	

function this.private.Update()
	this.private.Validate()
	
	for _,Faction in pairs(this.private.Paragon) do
		lib.faction.UpdateByID(Faction.FactionID)
		lib.quest.UpdateByID(Faction.EmissaryID)
		lib.item.UpdateByID(Faction.BoxID)
		
		if(Faction.mounts ~= nil) then
			for _,Mount in pairs(Faction.mounts) do
				lib.item.UpdateByID(Mount.ItemID)
				lib.journal.mount.UpdateByID(Mount.ID)
			end
		end
		
		if(Faction.pets ~= nil) then
			for _,Pet in pairs(Faction.pets) do
				lib.item.UpdateByID(Pet.ItemID)
				lib.journal.pet.UpdateByID(Pet.ID)
			end
		end
		
		if(Faction.toys ~= nil) then
			for _,Toy in pairs(Faction.toys) do
				lib.item.UpdateByID(Toy.ItemID)
				lib.journal.toy.UpdateByID(Toy.ItemID)
			end
		end
	end
	
	local out = lib.chat.output
	out.ClearBuffer()
	
	this.private.BuildMissing()
	
	local OutputFunction = nil
	
	for _,Faction in pairs(this.private.Missing) do
		--master line
		if(Faction.SomethingMissing == true) then
			local msg = nil
			local RepStatus = " "
			
			if(Faction.RepNext ~= 0) then
				RepStatus = " ("..Faction.Rep.." / " ..Faction.RepNext..")"
			end
			
			OutputFunction = out.StoreDone
			if(Faction.EmissaryActive == true) then
				OutputFunction = out.StoreTodo
				
				msg = Faction.EmissaryLink..RepStatus.." "..Faction.EmissaryTimeLeft
				
			elseif(option.ParagonEmissary == true) then
				OutputFunction = out.StoreTodo
				
				msg = Faction.Name..RepStatus
			end		
			
			OutputFunction(msg)
		else
			out.StoreCompleted(Faction.Name)
		end
		
		--paragon reward available
		if(Faction.RewardPending == true) then
			out.StoreTodo(Faction.RewardLink.." waiting for you!")
		end
		
		if(Faction.Mounts ~= nil) then
			for _,Mount in pairs(Faction.Mounts) do
				if(Mount[1] == true) then
					out.StoreCompleted(Mount[2])
				else
					OutputFunction(Mount[2])
				end
			end
		end
		
		if(Faction.Pets ~= nil) then
			for _,Pet in pairs(Faction.Pets) do
				if(Pet[1] == true) then
					out.StoreCompleted(Pet[2].." ("..Pet[3].." / "..Pet[4]..")")
				else
					OutputFunction(Pet[2])
				end
			end
		end
		
		if(Faction.Toys ~= nil) then
			for _,Toy in pairs(Faction.Toys) do
				if(Toy[1] == true) then
					out.StoreCompleted(Toy[2])
				else
					OutputFunction(Toy[2])
				end
			end
		end
		
	end
	
	return
end

function this.CheckStatus()
	this.private.Validate()
	
	this.private.Update()
	if(lib.chat.output.GetNumLines() == 0) then
		return false
	end
	
	return true
end

function this.Script()
	this.private.Validate()
	
	this.private.Update()
	lib.chat.output.PrintModule(this.Name)
	
	return
end

mod[#mod+1] =
{
	CheckStatus	= this.CheckStatus,
	Text		= this.Name,
	Script		= this.Script
}
