if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.LegionWQRecipes = {}
local this = ttd2.LegionWQRecipes
this.Name = "[Legion] WQ-Recipes"

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
		this.private.set = true
	end
	
	return
end

function this.private.Init()
	if(this.private.set == true) then
		return
	end
	
	--in this table we will sort the WQs nicely for better readability and bug-tracking
	local AllWQRecipes =
	{
		["Neutral"] =
		{
			["Alchemy"] =
			{
				ProfessionID	= 171,
				Recipes			= 
				{
					{ ItemID = 142121, WQID = 43513 },	--Recipe: Potion of Prolonged Power
					{ ItemID = 151658, WQID = 48318 },	--Recipe: Lightblood Elixir
					{ ItemID = 151704, WQID = 48323 }	--Recipe: Tears of the Naaru
				}
			},
			["Blacksmithing"] =
			{
				ProfessionID	= 164,
				Recipes			= 
				{
					{ ItemID = 123931, WQID = 41633 },	--Recipe: Leystone Greaves
					{ ItemID = 123936, WQID = 41634 },	--Recipe: Leystone Armguards
					{ ItemID = 137605, WQID = 41635 },	--Recipe: Leystone Boots
					{ ItemID = 123939, WQID = 41636 },	--Recipe: Leystone Breastplate
					{ ItemID = 123938, WQID = 41637 },	--Recipe: Leystone Pauldrons
					{ ItemID = 137606, WQID = 41638 }	--Recipe: Leystone Gauntlets
				}
			},
			["Enchanting"] =
			{
				ProfessionID	= 333,
				Recipes			=
				{
					{ ItemID = 128596, WQID = 41669 },	--Formula: Enchant Ring - Word of Critical Strike
					{ ItemID = 128605, WQID = 41670 },	--Formula: Enchant Cloak - Word of Agility
					{ ItemID = 128604, WQID = 41671 },	--Formula: Enchant Cloak - Word of Strength
					{ ItemID = 128597, WQID = 41672 },	--Formula: Enchant Ring - Word of Haste
					{ ItemID = 128598, WQID = 41673 },	--Formula: Enchant Ring - Word of Mastery
					{ ItemID = 128606, WQID = 41674 }	--Formula: Enchant Cloak - Word of Intellect
				}
			},			
			["Engineering"] =
			{
				ProfessionID	= 202,
				Recipes			=
				{
					{ ItemID = 137721, WQID = 41676 },	--Schematic: Pump-Action Bandage Gun
					{ ItemID = 137723, WQID = 41677 },	--Schematic: Auto-Hammer
					{ ItemID = 137722, WQID = 41678 },	--Schematic: Gunpack
					{ ItemID = 137719, WQID = 41679 },	--Schematic: Deployable Bullet Dispenser
					{ ItemID = 137724, WQID = 41680 }	--Schematic: Failure Detection Pylon
				}
			},
			["Inscription"] =
			{
				ProfessionID	= 773,
				Recipes			=
				{
					{ ItemID = 137772, WQID = 41663 },	--Vantus Rune Technique: Elerethe Renferal
					{ ItemID = 137770, WQID = 41664 },	--Vantus Rune Technique: Dragons of Nightmare
					{ ItemID = 162362, WQID = 41665 },	--Vantus Rune Technique: Ursoc
					{ ItemID = 137768, WQID = 41666 },	--Vantus Rune Technique: Nythendra
					{ ItemID = 137771, WQID = 41667 },	--Vantus Rune Technique: Xavius
					{ ItemID = 137769, WQID = 41668 }	--Vantus Rune Technique: Il'gynoth, The Heart of Corruption
				}
			},
			["Jewelcrafting"] =
			{
				ProfessionID	= 755,
				Recipes			=
				{
					{ ItemID = 137771, WQID = 41651 },	--Design: Azsunite Pendant
					{ ItemID = 137838, WQID = 41652 },	--Design: Deep Amber Loop
					{ ItemID = 137842, WQID = 41653 },	--Design: Skystone Pendant
					{ ItemID = 137865, WQID = 41654 },	--Design: Queen's Opal Loop
					{ ItemID = 137866, WQID = 41655 },	--Design: Queen's Opal Pendant
					{ ItemID = 137840, WQID = 41656 }	--Design: Azsunite Loop
				}
			},
			["Leatherworking"] =
			{
				ProfessionID	= 165,
				Recipes			=
				{
					{ ItemID = 137914, WQID = 41639 },	--Recipe: Battlebound Spaulders
					{ ItemID = 137878, WQID = 41640 },	--Recipe: Warhide Mask
					{ ItemID = 137908, WQID = 41641 },	--Recipe: Battlebound Armbands
					{ ItemID = 137880, WQID = 41642 },	--Recipe: Warhide Footpads
					{ ItemID = 137909, WQID = 41643 },	--Recipe: Battlebound Leggings
					{ ItemID = 137879, WQID = 41644 }	--Recipe: Warhide Gloves
				}
			},
			["Skinning"] =
			{
				ProfessionID	= 393,
				Recipes			=
				{
					{ ItemID = 139895, WQID = 42819 }	--Skinning Technique: Legion Butchery
				}
			},
			["Tailoring"] =
			{
				ProfessionID	= 197,
				Recipes			=
				{
					{ ItemID = 137961, WQID = 41648 },	--Pattern: Silkweave Bracers
					{ ItemID = 137963, WQID = 41645 },	--Pattern: Silkweave Epaulets
					{ ItemID = 138012, WQID = 41646 },	--Pattern: Silkweave Gloves
					{ ItemID = 138013, WQID = 41650 },	--Pattern: Silkweave Hood
					{ ItemID = 137964, WQID = 41647 },	--Pattern: Silkweave Robe
					{ ItemID = 138014, WQID = 41649 }	--Pattern: Silkweave Slippers
				}
			}
		},
		["Alliance"] = {},
		["Horde"] = {}
	}
	
	--build a data table based on our actual faction
	local MyFaction = lib.unit.GetPlayerFaction()
	
	local function TransferData(From, To)
		for _,Profession in pairs(From) do
			To[Profession.ProfessionID] = {}
			for _,Recipe in pairs(Profession.Recipes) do
				To[Profession.ProfessionID][Recipe.ItemID] = Recipe.WQID
			end
		end
	end
	
	if(MyFaction == "Neutral") then
		this.private.WQRecipes = {}
		TransferData(AllWQRecipes["Neutral"], this.private.WQRecipes)
	elseif(MyFaction == "Alliance") then	
		this.private.WQRecipes = {}
		TransferData(AllWQRecipes["Neutral"], this.private.WQRecipes)
		TransferData(AllWQRecipes["Alliance"], this.private.WQRecipes)
	elseif(MyFaction == "Horde") then	
		this.private.WQRecipes = {}
		TransferData(AllWQRecipes["Neutral"], this.private.WQRecipes)
		TransferData(AllWQRecipes["Horde"], this.private.WQRecipes)
	else
		--in case some strange panda-wannabe ever tries this in the future...
		lib.chat.error(this.Name..": invalid player faction: "..MyFaction)
	end
	
	--init recipe ItemID data
	for ProfessionID,ProfessionData in pairs(this.private.WQRecipes) do
		for ItemID,WQID in pairs(ProfessionData) do
			lib.item.AddByID(ItemID)
		end
	end
	
	return
end

function this.private.Update()
	this.private.Validate()	
	
	local out = lib.chat.output
	out.ClearBuffer()
	
	--first some exclusions
	local MyLevel = lib.unit.GetPlayerLevel()
	if(MyLevel < 110) then
		return
	end
	
	--assume tooltips are ready
	this.private.StillLoadingTooltips = false
	for ProfID,ProfData in pairs(this.private.WQRecipes) do
	
		--Spartans, what is your profession?
		if(lib.professions.DoesCharacterHaveProfession(ProfID) == true) then
			
			for ItemID,WQID in pairs(ProfData) do
				
				if(lib.recipe.IsRecipeInfoAvailable(ItemID) == false) then
					--it's important to still continue looping after finding the first incomplete tooltip to batch API requests
					this.private.StillLoadingTooltips = true
				else
					
					local RecipeStatus	= lib.recipe.IsRecipeLearned(ItemID)
					local WQStatus		= lib.worldquest.IsActive(WQID)
					
					if(RecipeStatus == true) then
						out.StoreCompleted(lib.item.GetByID(ItemID).Link)
					elseif(WQStatus == true) then
						out.StoreTodo(lib.item.GetByID(ItemID).Link.." - "..lib.chat.complex.GetWQStatusString(WQID))
					else
						out.StoreDone(lib.item.GetByID(ItemID).Link.." - "..lib.chat.complex.GetWQStatusString(WQID))
					end
				end
			end
		end
	end
		
	return
end

function this.CheckStatus()
	this.private.Validate()
	
	this.private.Update()
	
	if(	(lib.chat.output.GetNumLines() ~= 0) or
		(this.private.StillLoadingTooltips == true) )then
		return true
	end
	
	--lib.chat.output.PrintModule(this.Name)
	
	return false
end

function this.Script()
	this.private.Validate()
	
	this.private.Update()
	
	if(this.private.StillLoadingTooltips == true) then
		lib.chat.output.ClearBuffer()
		lib.chat.output.StoreTodo("Loading tooltips. Please wait a few seconds and try again.")
	elseif(lib.chat.output.GetNumLines() == 0) then
		lib.chat.output.ClearBuffer()
		lib.chat.output.StoreTodo("Please refresh modules.")
	end
	
	lib.chat.output.PrintModule(this.Name)
	
	return
end

mod[#mod+1] =
{
	CheckStatus	= this.CheckStatus,
	Text		= this.Name,
	Script		= this.Script
}
